import { isCoValueClass, } from "../internal.js";
/** @category Schema definition */
export const co = {
    string: {
        [SchemaInit]: "json",
    },
    number: {
        [SchemaInit]: "json",
    },
    boolean: {
        [SchemaInit]: "json",
    },
    null: {
        [SchemaInit]: "json",
    },
    literal: (..._lit) => {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        return { [SchemaInit]: "json" };
    },
    json: () => {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        return { [SchemaInit]: "json" };
    },
    encoded: (arg) => {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        return { [SchemaInit]: { encoded: arg } };
    },
    ref: (arg) => {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        return { [SchemaInit]: arg };
    },
    items: ItemsSym,
    members: MembersSym,
};
export function isRefEncoded(schema) {
    return typeof schema === "function";
}
export function instantiateRefEncoded(schema, raw) {
    return isCoValueClass(schema)
        ? schema.fromRaw(raw)
        : schema(raw).fromRaw(raw);
}
import { Date } from "@effect/schema/Schema";
import { SchemaInit, ItemsSym, MembersSym } from "./symbols.js";
/** @category Schema definition */
export const Encoders = {
    Date,
};
//# sourceMappingURL=schema.js.map